// Copyright 2017 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file

// Flags: --allow-natives-syntax


// It optimizes and lazily deoptimizes 2 functions several times.

function f() {
  g();
}

function g() {
  v8DeoptimizeFunction(f);
}

function a() {
  b();
}

function b() {
  v8DeoptimizeFunction(a);
}

v8PrepareFunctionForOptimization(f);
f(); f();
v8OptimizeFunctionOnNextCall(f);
f();
v8PrepareFunctionForOptimization(a);
a(); a();
v8OptimizeFunctionOnNextCall(a);
a();
for(var i = 0; i < 5; i++) {
  v8PrepareFunctionForOptimization(f);
  v8OptimizeFunctionOnNextCall(f);
  f();
  v8PrepareFunctionForOptimization(a);
  v8OptimizeFunctionOnNextCall(a);
  a();
}
