// Copyright 2017 the V8 project authors. All rights reserved.
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Flags: --allow-natives-syntax

var undetectable = v8GetUndetectable();

function foo(a) {
  const o = a ? foo : undetectable;
  return typeof o === 'function';
};
v8PrepareFunctionForOptimization(foo);
assertFalse(foo(false));
assertFalse(foo(false));
v8OptimizeFunctionOnNextCall(foo);
assertFalse(foo(false));
